/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.records;


import com.tabajara.base.tables.Hispropriedades;
import com.tabajara.base.tables.interfaces.IHispropriedades;

import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import java.sql.Date;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record8;
import org.jooq.Row8;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class HispropriedadesRecord extends UpdatableRecordImpl<HispropriedadesRecord> implements VertxPojo, Record8<Integer, Integer, Integer, Integer, Integer, String, Date, String>, IHispropriedades {

    private static final long serialVersionUID = 277614709;

    /**
     * Setter for <code>public.hispropriedades.hispoptid</code>.
     */
    @Override
    public HispropriedadesRecord setHispoptid(Integer value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>public.hispropriedades.hispoptid</code>.
     */
    @Override
    public Integer getHispoptid() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>public.hispropriedades.fkardid</code>.
     */
    @Override
    public HispropriedadesRecord setFkardid(Integer value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>public.hispropriedades.fkardid</code>.
     */
    @Override
    public Integer getFkardid() {
        return (Integer) get(1);
    }

    /**
     * Setter for <code>public.hispropriedades.fktanid</code>.
     */
    @Override
    public HispropriedadesRecord setFktanid(Integer value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>public.hispropriedades.fktanid</code>.
     */
    @Override
    public Integer getFktanid() {
        return (Integer) get(2);
    }

    /**
     * Setter for <code>public.hispropriedades.fksenid</code>.
     */
    @Override
    public HispropriedadesRecord setFksenid(Integer value) {
        set(3, value);
        return this;
    }

    /**
     * Getter for <code>public.hispropriedades.fksenid</code>.
     */
    @Override
    public Integer getFksenid() {
        return (Integer) get(3);
    }

    /**
     * Setter for <code>public.hispropriedades.fkempid</code>.
     */
    @Override
    public HispropriedadesRecord setFkempid(Integer value) {
        set(4, value);
        return this;
    }

    /**
     * Getter for <code>public.hispropriedades.fkempid</code>.
     */
    @Override
    public Integer getFkempid() {
        return (Integer) get(4);
    }

    /**
     * Setter for <code>public.hispropriedades.hora</code>.
     */
    @Override
    public HispropriedadesRecord setHora(String value) {
        set(5, value);
        return this;
    }

    /**
     * Getter for <code>public.hispropriedades.hora</code>.
     */
    @Override
    public String getHora() {
        return (String) get(5);
    }

    /**
     * Setter for <code>public.hispropriedades.dia</code>.
     */
    @Override
    public HispropriedadesRecord setDia(Date value) {
        set(6, value);
        return this;
    }

    /**
     * Getter for <code>public.hispropriedades.dia</code>.
     */
    @Override
    public Date getDia() {
        return (Date) get(6);
    }

    /**
     * Setter for <code>public.hispropriedades.medida</code>.
     */
    @Override
    public HispropriedadesRecord setMedida(String value) {
        set(7, value);
        return this;
    }

    /**
     * Getter for <code>public.hispropriedades.medida</code>.
     */
    @Override
    public String getMedida() {
        return (String) get(7);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record8 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row8<Integer, Integer, Integer, Integer, Integer, String, Date, String> fieldsRow() {
        return (Row8) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row8<Integer, Integer, Integer, Integer, Integer, String, Date, String> valuesRow() {
        return (Row8) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return Hispropriedades.HISPROPRIEDADES.HISPOPTID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field2() {
        return Hispropriedades.HISPROPRIEDADES.FKARDID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field3() {
        return Hispropriedades.HISPROPRIEDADES.FKTANID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field4() {
        return Hispropriedades.HISPROPRIEDADES.FKSENID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field5() {
        return Hispropriedades.HISPROPRIEDADES.FKEMPID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field6() {
        return Hispropriedades.HISPROPRIEDADES.HORA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Date> field7() {
        return Hispropriedades.HISPROPRIEDADES.DIA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field8() {
        return Hispropriedades.HISPROPRIEDADES.MEDIDA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getHispoptid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component2() {
        return getFkardid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component3() {
        return getFktanid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component4() {
        return getFksenid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component5() {
        return getFkempid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component6() {
        return getHora();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Date component7() {
        return getDia();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component8() {
        return getMedida();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getHispoptid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value2() {
        return getFkardid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value3() {
        return getFktanid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value4() {
        return getFksenid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value5() {
        return getFkempid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value6() {
        return getHora();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Date value7() {
        return getDia();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value8() {
        return getMedida();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HispropriedadesRecord value1(Integer value) {
        setHispoptid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HispropriedadesRecord value2(Integer value) {
        setFkardid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HispropriedadesRecord value3(Integer value) {
        setFktanid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HispropriedadesRecord value4(Integer value) {
        setFksenid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HispropriedadesRecord value5(Integer value) {
        setFkempid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HispropriedadesRecord value6(String value) {
        setHora(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HispropriedadesRecord value7(Date value) {
        setDia(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HispropriedadesRecord value8(String value) {
        setMedida(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HispropriedadesRecord values(Integer value1, Integer value2, Integer value3, Integer value4, Integer value5, String value6, Date value7, String value8) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        value7(value7);
        value8(value8);
        return this;
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public void from(IHispropriedades from) {
        setHispoptid(from.getHispoptid());
        setFkardid(from.getFkardid());
        setFktanid(from.getFktanid());
        setFksenid(from.getFksenid());
        setFkempid(from.getFkempid());
        setHora(from.getHora());
        setDia(from.getDia());
        setMedida(from.getMedida());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public <E extends IHispropriedades> E into(E into) {
        into.from(this);
        return into;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached HispropriedadesRecord
     */
    public HispropriedadesRecord() {
        super(Hispropriedades.HISPROPRIEDADES);
    }

    /**
     * Create a detached, initialised HispropriedadesRecord
     */
    public HispropriedadesRecord(Integer hispoptid, Integer fkardid, Integer fktanid, Integer fksenid, Integer fkempid, String hora, Date dia, String medida) {
        super(Hispropriedades.HISPROPRIEDADES);

        set(0, hispoptid);
        set(1, fkardid);
        set(2, fktanid);
        set(3, fksenid);
        set(4, fkempid);
        set(5, hora);
        set(6, dia);
        set(7, medida);
    }

    public HispropriedadesRecord(io.vertx.core.json.JsonObject json) {
        this();
        fromJson(json);
    }
}
